#include  "P16R16.H"

#define  MAX_BOARD_NUMBER    16

static	 WORD  wGetAddress=0;

static	 WORD  wBaseAddr0=0;
static	 WORD  wBaseAddr1=0;
static	 WORD  wBaseAddr2=0;
static	 WORD  wBaseAddr3=0;
static	 WORD  wBaseAddr4=0;
static	 WORD  wBaseAddr5=0;

static	 WORD wConfigSpace[MAX_BOARD_NUMBER][7];
static	 WORD wTotalBoards=0;
static	 WORD wActiveBoardNo=100;

WORD   GetAddress(void);
void  WriteAddress(UCHAR bBus, UCHAR bDevice, UCHAR bFunction, UCHAR bWhichLong);
/* -------------------------------------------------------------------- */

float  PCI_FloatSub2(float fA, float fB)
{
    return(fA-fB);
}

short  PCI_ShortSub2(short nA, short nB)
{
    return(nA-nB);
}

WORD  PCI_DriverInit(WORD *wBoards)
{
    WORD  wReturnCode;

    wReturnCode=GetAddress();
    if( wReturnCode )
    {
       *wBoards=0;
       return( wReturnCode );
    }

    *wBoards=wTotalBoards;
    return( wReturnCode );
}

WORD  PCI_DriverClose(void)
{
    return( NoError );
}

WORD  PCI_GetDriverVersion(WORD *wDriverVersion)
{
    *wDriverVersion=0x200;
    return( NoError );
}

/* -------------------------------------------------------------------- */
WORD  PCI_GetConfigAddressSpace(WORD wBoardNo,	 WORD *TypeID,
		      WORD *wAddress0, WORD *wAddress1, WORD *wAddress2,
		      WORD *wAddress3, WORD *wAddress4, WORD *wAddress5)
{
   if (wGetAddress==0)
   {
      if (GetAddress()!=0) return(FindBoardError);
   }

   if( wBoardNo>=wTotalBoards )
      return ExceedBoardNumber;
   *TypeID=wConfigSpace[wBoardNo][6];
   *wAddress0 =  wConfigSpace[wBoardNo][0];
   *wAddress1 =  wConfigSpace[wBoardNo][1];
   *wAddress2 =  wConfigSpace[wBoardNo][2];
   *wAddress3 =  wConfigSpace[wBoardNo][3];
   *wAddress4 =  wConfigSpace[wBoardNo][4];
   *wAddress5 =  wConfigSpace[wBoardNo][5];
   return(NoError);
}

/**************************************************************/
/*   Reading PCI card's configuration address space           */
/**************************************************************/
WORD   GetAddress(void)
{
    DWORD   dConfigAddress,dBaseAddress;
    WORD    HiWord,LoWord;
    WORD    ReturnCode;
    UCHAR   Bus,Device,Function,WhichLong;
    WORD    VendorID,DeviceID;
    WORD    wIrqNumber;

    wTotalBoards=0;   /* initial board number is 0 */

    Bus=0;
  for(Bus=0; Bus<10;  Bus++)
  {
    Function=0;
    WhichLong=1;
    for(Device=0;  Device<32;  Device++)
    {
       WhichLong=0;
       WriteAddress(Bus,Device,Function,WhichLong);
       VendorID=inport(0xcfc);
       DeviceID=inport(0xcfe);

       if( VendorID==0x1234 && DeviceID==0x1616 )
       {  /*----------- PCI-P16R16 --------------*
	  WhichLong=4;	 // Base Address 0
	  WriteAddress(Bus,Device,Function,WhichLong);
	  dBaseAddress=_inpd(0xcfc);
	  wBaseAddr0=(WORD)(dBaseAddress&0xfffe);
	  wConfigSpace[wTotalBoards][0]=wBaseAddr0;

	  /*----------------------------------------*/
	  WhichLong=5;	 /* Base Address 1 */
	  WriteAddress(Bus,Device,Function,WhichLong);
	  dBaseAddress=_inpd(0xcfc);
	  wBaseAddr1=(WORD)(dBaseAddress&0xfffe);
	  wConfigSpace[wTotalBoards][1]=wBaseAddr1;


	  /*------------------------------------------*/
	  WhichLong=6;	 /* Base Address 2 */
	  WriteAddress(Bus,Device,Function,WhichLong);
	  dBaseAddress=_inpd(0xcfc);
	  wBaseAddr2=(WORD)(dBaseAddress&0xfffe);
	  wConfigSpace[wTotalBoards][2]=wBaseAddr2;


	  /*------------------------------------------*/
	  WhichLong=7;	/* Base Address 3 */
	  WriteAddress(Bus,Device,Function,WhichLong);
	  dBaseAddress=_inpd(0xcfc);
	  wBaseAddr3=(WORD)(dBaseAddress&0xfffe);
	  wConfigSpace[wTotalBoards][3]=wBaseAddr3;

	  /*------------------------------------------*/
	  WhichLong=8;	 /* Base Address 4 */
	  WriteAddress(Bus,Device,Function,WhichLong);
	  dBaseAddress=_inpd(0xcfc);
	  wBaseAddr4=(WORD)(dBaseAddress&0xfffe);
	  wConfigSpace[wTotalBoards][4]=wBaseAddr4;

	  /*-------------------------------------------*/
	  WhichLong=9;	 /* Base Address 5 */
	  WriteAddress(Bus,Device,Function,WhichLong);
	  dBaseAddress=_inpd(0xcfc);
	  wBaseAddr5=(WORD)(dBaseAddress&0xfffe);
	  wConfigSpace[wTotalBoards][5]=wBaseAddr5;

	  /*----------- store the type name ID --------*/
	  wConfigSpace[wTotalBoards][6]=TYPE_P16R16;

	  /*-------------------------------------------*/
	  wTotalBoards++;  /* increment board number */

	  wGetAddress=1;
       }

       if( VendorID==0x1234 && DeviceID==0x0808 )
       {  /*---------- PCI-P8R8 -----------*/
	  WhichLong=4;	 /* Base Address 0 */
	  WriteAddress(Bus,Device,Function,WhichLong);
	  dBaseAddress=_inpd(0xcfc);
	  wBaseAddr0=(WORD)(dBaseAddress&0xfffe);
	  wConfigSpace[wTotalBoards][0]=wBaseAddr0;

	  /*------------------------------------------*/
	  WhichLong=5;	 /* Base Address 1 */
	  WriteAddress(Bus,Device,Function,WhichLong);
	  dBaseAddress=_inpd(0xcfc);
	  wBaseAddr1=(WORD)(dBaseAddress&0xfffe);
	  wConfigSpace[wTotalBoards][1]=wBaseAddr1;


	  /*------------------------------------------*/
	  WhichLong=6;	 /* Base Address 2 */
	  WriteAddress(Bus,Device,Function,WhichLong);
	  dBaseAddress=_inpd(0xcfc);
	  wBaseAddr2=(WORD)(dBaseAddress&0xfffe);
	  wConfigSpace[wTotalBoards][2]=wBaseAddr2;


	  /*------------------------------------------*/
	  WhichLong=7;	/* Base Address 3 */
	  WriteAddress(Bus,Device,Function,WhichLong);
	  dBaseAddress=_inpd(0xcfc);
	  wBaseAddr3=(WORD)(dBaseAddress&0xfffe);
	  wConfigSpace[wTotalBoards][3]=wBaseAddr3;

	  /*------------------------------------------*/
	  WhichLong=8;	 /* Base Address 4 */
	  WriteAddress(Bus,Device,Function,WhichLong);
	  dBaseAddress=_inpd(0xcfc);
	  wBaseAddr4=(WORD)(dBaseAddress&0xfffe);
	  wConfigSpace[wTotalBoards][4]=wBaseAddr4;

	  /*-------------------------------------------*/
	  WhichLong=9;	 /* Base Address 5 */
	  WriteAddress(Bus,Device,Function,WhichLong);
	  dBaseAddress=_inpd(0xcfc);
	  wBaseAddr5=(WORD)(dBaseAddress&0xfffe);
	  wConfigSpace[wTotalBoards][5]=wBaseAddr5;

	  /*---------- store the type name ID --------*/
	  wConfigSpace[wTotalBoards][6]=TYPE_P8R8;

	  wTotalBoards++;  /* increment board number */

	  wGetAddress=1;
       }
    }
  }
    if( wTotalBoards>16 )
       return( NotFoundBoard );
    else
       return( NoError );
}


void  WriteAddress(UCHAR bBus, UCHAR bDevice, UCHAR bFunction, UCHAR bWhichLong)
{

    DWORD   dOutData;
    WORD    HiWord,LoWord;
    UCHAR    HiByte,LoByte;

    HiWord=0x8000|bBus;

    HiByte=(bDevice<<3)|bFunction;
    LoByte=(bWhichLong<<2) & 0xfc;
    LoWord=( (WORD)HiByte<<8 )|LoByte;

    dOutData=( (DWORD)HiWord<<16 ) | LoWord;
    _outpd(0xcf8,dOutData);
}

/*----------------------------------------------*/
void   P16R16_DO(WORD BaseAddr, WORD wOutData)
{
      outport(BaseAddr,wOutData);
}
/*----------------------------------------------*/
WORD   P16R16_DI(WORD BaseAddr)
{
	WORD DigitalIn;

    DigitalIn=inport(BaseAddr);
    return DigitalIn;
}
/*----------------------------------------------*/
void   P8R8_DO(WORD BaseAddr, WORD wOutData)
{
      outportb(BaseAddr,wOutData);
}
/*----------------------------------------------*/
UCHAR  P8R8_DI(WORD BaseAddr)
{
    UCHAR DigitalIn;

    DigitalIn=inportb(BaseAddr);
    return DigitalIn;
}
